=== deps/rabbitmq_event_exchange/Makefile ===
PROJECT = rabbitmq_event_exchange

DEPS = rabbit_common rabbit
TEST_DEPS = rabbitmq_ct_helpers amqp_client

DEP_PLUGINS = rabbit_common/mk/rabbitmq-plugin.mk

# FIXME: Use erlang.mk patched for RabbitMQ, while waiting for PRs to be
# reviewed and merged.
ERLANG_MK_REPO = https://github.com/rabbitmq/erlang.mk.git
ERLANG_MK_COMMIT = rabbitmq-tmp

include rabbitmq-components.mk
include erlang.mk
