=== debian/changelog ===
rabbitmq-server (3.6.6-1) unstable; urgency=medium

  [ Ondřej Nový ]
  * Team upload.
  * New upstream release (Closes: #849849, CVE-2016-9877)
  * d/copyright: Fixed for new release
  * d/ocf: Removed, use upstream one

 -- Ondřej Kobližek <koblizeko@gmail.com>  Mon, 02 Jan 2017 15:49:03 +0100

rabbitmq-server (3.6.5-1) unstable; urgency=medium

  [ James Page ]
  * New upstream release (Closes: #812377):
    - Builds fine with the new erlang (Closes: #837241).
  * [fa2d29e] Update watch file for upstream xz compression. (Closes: #813628).
  * [b008e08] Imported Upstream version 3.6.0.
  * [d0dc477] Update gbp configuration for dch use.

  [ Thomas Goirand ]
  * Also packaging the rabbitmqadmin cli.
  * Do not do dh_auto_clean, as it removes all the deps folder.
  * Disabled tests, as they download from github.
  * Replaced git-core transition package by git in build-depends.
  * Added rsync as build-depends-indep.
  * Fix DESTDIR=$(DEB_DESTDIR) PREFIX=/usr as upstream Makefile changed.
  * Added python-all and dh-python as build-depends.
  * Update of debian/copyright for the new deps/* path from upstream, updated
    debian/* info and fixed order.
  * Copy some stuff from the upstream pacakging in debian/rules.
  * Runtime depends on lsb-base.
  * Overrides lintian false positive error js source missing.

  [ Ondřej Nový ]
  * Fixed VCS URLs (https).
  * Fixed python shebang.
  * Standards-Version is 3.9.8 now (no change).

 -- Thomas Goirand <zigo@debian.org>  Sun, 14 Feb 2016 13:35:22 +0800
